#include "Gra.ch"
#include "Xbp.ch"
#INCLUDE "dll.CH"
#include "os.ch"

#INCLUDE "ot4xb.CH"
#include "WinUser_constants.ch"
#include "WinGdi_constants.ch"

PROCEDURE AppSys
RETURN

PROCEDURE Main
LOCAL oDlg, oPS
LOCAL oFont, oFontDlg
LOCAL hDC
LOCAL oStatic1,oStatic2,oStatic3
LOCAL nXSize,nYSize
LOCAL aPPTopLeft := {{XBP_PP_ORIGIN,XBP_ORIGIN_TOPLEFT}}
LOCAL aSize := AppDeskTop():CurrentSize()
LOCAL cText := "The quick brown fox jumps over the lazy dog"

#IFDEF DEBUG
   SET ALTER TO _LOGFILE.TXT
   SET ALTER ON
#ENDIF

   aSize[1] -= 100
   aSize[2] -= 100

   oDlg         := XbpDialog():new( ,, {0,0}, aSize )
   oDlg:title   := "Font Demo"
   oDlg:taskList := .T.
   oDlg:create()
   CenterControl(oDlg)

   aSize  := oDlg:DrawingArea:CurrentSize()
   nXSize := aSize[1]-20
   nYSize := (aSize[2]-30) / 3

   oStatic1 := XbpStatic():new( oDlg:DrawingArea,, {10,nYSize*2}, {nXSize,nYSize}, aPPTopLeft )
   oStatic1:type    := XBPSTATIC_TYPE_TEXT
   oStatic1:options := XBPSTATIC_TEXT_WORDBREAK
   oStatic1:Caption := "Xbase: Font"
   oStatic1:create()

   oStatic2 := XbpStatic():new( oDlg:DrawingArea,, {10,nYSize*1}, {nXSize,nYSize}  )
   oStatic2:type    := XBPSTATIC_TYPE_TEXT
*  oStatic2:options := XBPSTATIC_TEXT_WORDBREAK
   oStatic2:Caption := "Beyes: Font"
   oStatic2:create()

   oStatic3 := XbpStatic():new( oDlg:DrawingArea,, {10,       0}, {nXSize,nYSize}  )
   oStatic3:type    := XBPSTATIC_TYPE_TEXT
*  oStatic3:options := XBPSTATIC_TEXT_WORDBREAK
   oStatic3:Caption := "Ot4xb: Font"
   oStatic3:create()

   oFontDlg := XbpFontDialog():New()
*   oFontDlg := XbpFontDialog():New(oDlg:DrawingArea)
*   oFontDlg := XbpFontDialog():New(AppDeskTop())
*  oFontDlg:vectorOnly := .T.
*  oFontDlg:fixedOnly  := .T.
*  oFontDlg:proportionalOnly := .T.

   oFontDlg:familyName := "Arial"
   oFontDlg:nominalPointSize := 9
   oFontDlg:Create()                 // Font-Dialog erzeugen

   DO WHILE (oFont := oFontDlg:display(XBP_DISP_APPMODAL)) <> NIL
                                     // Modaler Font-Dialog

      SetAppFocus(oDlg)
      oDlg:SetTitle( LTRIM(STR(oFont:nominalPointSize))+"."+oFont:familyName )

      oStatic1:SetCaption(" ")
      oStatic2:SetCaption(" ")
      oStatic3:SetCaption(" ")

      oStatic1:SetFont(oFont)
      oStatic1:SetCaption(cText+" --- Xbase++")

      ShowAPI(oStatic2,oStatic3,oFont,cText)

      DO WHILE NextAppEvent() <> 0   // Alle Ereignisse aus der
         AppEvent()                  // Warteschlange entfernen
      ENDDO
      AppEvent(,,,0)                 // Warten auf nchstes Ereignis

      oFontDlg:familyName := ;       // Anfangselement fr
         oFont:familyName            // Combo-Box bestimmen

      oFontDlg:nominalPointSize := ;
         oFont:nominalPointSize

   ENDDO

#IFDEF DEBUG
   SET ALTER OFF
   SET ALTER TO
#ENDIF

RETURN

// ---------------------------------------------

STATIC PROCEDURE ShowAPI(oStatic2,oStatic3,oFont,cItemText)
LOCAL hDC2
LOCAL hDC3
LOCAL hFont2
LOCAL hFont3
LOCAL nLeft ,nTop , nRight ,nBottom
LOCAL aSize
LOCAL rcItem
LOCAL cAlign := DT_LEFT
LOCAL cText2
LOCAL cText3

   aSize := oStatic2:CurrentSize()
   nLeft    := 10
   nTop     := 10
   nRight   := aSize[1]-10
   nBottom  := aSize[2]

   rcItem := {0,0,aSize[1],aSize[2]}

   hDC2  := oStatic2:winDevice():getHDC()
   hDC3  := oStatic3:winDevice():getHDC()

   // this is from Guenter Beyes
   //
   hFont2 := HandleFromFont( oFont )
   SelectObject( hDC2, hFont2 )
   cText2   := cItemText+" --- Beyes"
   @Gdi32:SetBkColor(hDC2, AutomationTranslateColor(XBPSYSCLR_DIALOGBACKGROUND,.F.))
   @user32:DrawTextA( hDC2       ,;
                  cText2+CHR(0)  ,;
                  LEN(cText2 )   ,;
                  {nLeft ,nTop , nRight ,nBottom },;
                  nOr(cAlign, DT_WORDBREAK) )
   DeleteObject( hFont2 )


   // this is ot4xb ...
   //
   hFont3 := SetNewHfont(oFont, hDC3)
   SelectObject( hDC3, hFont3 )
   cText3   := cItemText+" --- Ot4xb"
   @Gdi32:SetBkColor(hDC3, AutomationTranslateColor(XBPSYSCLR_DIALOGBACKGROUND,.F.))
   @user32:DrawTextA( hDC3 ,;
                      cText3 +CHR(0)     ,;
                  LEN(cText3)            ,;
                  {nLeft ,nTop , nRight ,nBottom },;
                  nOr(cAlign, DT_WORDBREAK) )
   DeleteObject( hFont3 )

RETURN

// ---------------------------------------------

STATIC FUNCTION SetNewHfont(oFont, hDC)
LOCAL cName
LOCAL nheigh
LOCAL nwidth
LOCAL nSize
LOCAL nhigh := 0
LOCAL hFont
LOCAL nYLogPixel := @Gdi32:GetDeviceCaps( hDC, LOGPIXELSY )
LOCAL aFlags := {}
LOCAL nFlags := 0
LOCAL i,iMax
LOCAL cMacro

*LOCAL hDC := @user32:GetDC( HWND_DESKTOP )
*LOCAL nx1,nx2

   cName  := oFont:familyName
   nheigh := oFont:height
   nwidth := oFont:width
   nSize  := oFont:nominalPointSize

   IF( oFont:bold      , AADD(aFlags, 1),NIL)
   IF( oFont:italic    , AADD(aFlags, 2),NIL)
   IF( oFont:underscore, AADD(aFlags, 4),NIL)
   IF( oFont:strikeOut , AADD(aFlags, 8),NIL)

   iMax := LEN(aFlags)
   IF iMax > 0
      cMacro := "nOr("
      FOR i := 1 TO iMax-1
         cMacro += LTRIM(STR(aFlags[i]))+","
      NEXT
      cMacro += LTRIM(STR(aFlags[iMax]))+")"
      nFlags := &(cMacro)
   ENDIF

   IF OnOSVersion() < 6
      nhigh := ROUND(nSize * (10.0 +0.05) / ( 72/nYLogPixel ),0)
   ELSE
      nhigh := ROUND(nSize * ( 9.0 +0.05) / ( 72/nYLogPixel ),0)
   ENDIF
ALTD()
*  onDummy(cName,nSize,nhigh,nwidth)

   hFont := @ot4xb:_create_font_( hDC   ,;
                                  cName ,; // szFaceName
                                  nhigh ,; // iDeciPtHeight
                                  0     ,; // iDeciPtWidth
                                  nFlags,; // iAttributes
                                  0      ) // fLogRes

*   @user32:ReleaseDC( HWND_DESKTOP,hDC)
*   hDC := 0

RETURN hFont

// ---------------------------------------------

STATIC FUNCTION HandleFromFont( oFont )
LOCAL nHeight
LOCAL nWidth
LOCAL nEscapement
LOCAL nOrientation
LOCAL fnWeight
LOCAL fdwItalic
LOCAL fdwUnderline
LOCAL fdwStrikeOut
LOCAL fdwCharSet
LOCAL fdwOutputPrecision
LOCAL fdwClipPrecision
LOCAL fdwQuality
LOCAL fdwPitchAndFamily
LOCAL cFaceName
*LOCAL nLogPixelsY

   nHeight            := oFont:Height
   nWidth             := 0             // let the GDI font mapper figure that one out

   // For the following six font parameters,
   // there is no, or no complete, match in XbpFont IVars, unfortunately;
   // so they should be guessed, if at all possible.

   nEscapement        := 0
   nOrientation       := 0
   fdwOutputPrecision := 0
   fdwClipPrecision   := 0
   fdwQuality         := 0  // partly available via oFont:antiAliased
   fdwPitchAndFamily  := 0  // pitch is available via oFont:Fixed, font family is N/A

   fnWeight           := oFont:WeightClass
   IF fnWeight = 0
      IF oFont:bold
         fnWeight := FW_BOLD
      ELSE
         fnWeight := FW_NORMAL
      ENDIF
   ENDIF
   fdwItalic          := IIF( oFont:italic, 1, 0 )
   fdwUnderline       := IIF( oFont:underscore, 1, 0 )
   fdwStrikeOut       := IIF( oFont:strikeOut, 1, 0 )
   fdwCharset         := oFont:codePage

   IF oFont:status() = XBP_STAT_CREATE
      // oFont:generic is only available after oFont:create().
      IF ! oFont:generic
         fdwOutputPrecision := OUT_DEVICE_PRECIS  // device font
      ELSEIF oFont:vector
         fdwOutputPrecision := OUT_TT_PRECIS      // TrueType font
      ELSE
         fdwOutputPrecision := OUT_RASTER_PRECIS  // Bitmap font
      ENDIF
   ELSE
      IF oFont:vector
         fdwOutputPrecision := OUT_TT_PRECIS      // TrueType font
      ELSE
         fdwOutputPrecision := OUT_DEFAULT_PRECIS // let the GDI font mapper decide
      ENDIF
   ENDIF

   IF oFont:Fixed
      fdwPitchAndFamily  := FIXED_PITCH
   ELSE
      fdwPitchAndFamily  := VARIABLE_PITCH
   ENDIF

   fdwClipPrecision   := CLIP_STROKE_PRECIS
   fdwQuality         := DRAFT_QUALITY
   IF oFont:antiAliased
      fdwQuality      := ANTIALIASED_QUALITY
   ENDIF

   cFaceName          := oFont:familyName

RETURN @gdi32:CreateFontA( nHeight, nWidth, nEscapement, nOrientation,;
                   fnWeight, fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, ;
                   fdwOutputPrecision, fdwClipPrecision, fdwQuality, ;
                   fdwPitchAndFamily, cFaceName )


// ----------------------------------------------

STATIC FUNCTION SelectObject( hDC, hObject )

STATIC tpl
IF tpl == NIL
   tpl := DllPrepareCall( "gdi32.dll", DLL_STDCALL, "SelectObject" )
ENDIF

RETURN DllExecuteCall( tpl, hDC, hObject )

// ----------------------------------------------
/*
Destroy a Windows graphics object, such as a font.
*/

STATIC FUNCTION DeleteObject( hObject )

STATIC tpl
IF tpl == NIL
   tpl := DllPrepareCall( "gdi32.dll", DLL_STDCALL, "DeleteObject" )
ENDIF

RETURN ( DllExecuteCall( tpl, hObject ) <> 0 )

// ---------------------------------------------
/*
Destroy a device context created by CreateDC(), e.g. a printer device context.
*/

STATIC FUNCTION DeleteDC( hDC )

STATIC tpl
IF tpl == NIL
   tpl := DllPrepareCall( "gdi32.dll", DLL_STDCALL, "DeleteDC" )
ENDIF

RETURN ( DllExecuteCall( tpl, hDC ) <> 0 )

// ---------------------------------------------

STATIC FUNCTION OnOSVersion()
RETURN VAL( OS( OS_VERSION ) )

// ---------------------------------------------

STATIC PROCEDURE onDummy()
LOCAL iMax   := PCOUNT()
LOCAL i
LOCAL cText  := ""
LOCAL xValue

#IFDEF DEBUG

   FOR i := 1 TO iMax - 1
      cText += Var2Char( PValue( i ) ) + CHR( 9 )
   NEXT
   cText += Var2Char( PValue( iMax ) )

   SET CONSOLE OFF
   SET ALTER ON
   ? cText
   SET ALTER OFF
   SET CONSOLE ON

#ENDIF

RETURN

*
* eof
*
